package gregapi.old.metatileentity.implementations;

import gregapi.old.Textures;
import gregapi.old.interfaces.tileentity.IGregTechTileEntity;
import gregapi.old.metatileentity.MetaTileEntity;
import gregapi.render.BlockTextureDefault;
import gregapi.render.ITexture;
import gregapi.util.UT;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.common.util.ForgeDirection;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.IFluidHandler;

public class GT_MetaTileEntity_Hatch_Output extends GT_MetaTileEntity_Hatch {
	public byte mMode = 0;

	public GT_MetaTileEntity_Hatch_Output(int aID, String aName, String aNameRegional, int aTier) {
		super(aID, aName, aNameRegional, aTier, 3, "Use Screwdriver to specify Output Type");
	}
	
	public GT_MetaTileEntity_Hatch_Output(String aName, int aTier, String aDescription, ITexture[][][] aTextures) {
		super(aName, aTier, 3, aDescription, aTextures);
	}
	
	@Override
	public ITexture[] getTexturesActive(ITexture aBaseTexture) {
		return new ITexture[] {aBaseTexture, new BlockTextureDefault(Textures.BlockIcons.OVERLAY_PIPE_OUT)};
	}
	
	@Override
	public ITexture[] getTexturesInactive(ITexture aBaseTexture) {
		return new ITexture[] {aBaseTexture, new BlockTextureDefault(Textures.BlockIcons.OVERLAY_PIPE_OUT)};
	}
	
	@Override public boolean isSimpleMachine()						{return true;}
	@Override public boolean isFacingValid(byte aFacing)			{return true;}
	@Override public boolean isAccessAllowed(EntityPlayer aPlayer)	{return true;}
	@Override public boolean isLiquidInput(byte aSide)				{return false;}
    
	@Override
	public MetaTileEntity newMetaEntity(IGregTechTileEntity aTileEntity) {
		return new GT_MetaTileEntity_Hatch_Output(mName, mTier, mDescription, mTextures);
	}
	
	@Override
	public boolean onRightclick(IGregTechTileEntity aBaseMetaTileEntity, EntityPlayer aPlayer) {
		if (aBaseMetaTileEntity.isClientSide()) return true;
		aBaseMetaTileEntity.openGUI(aPlayer);
		return true;
	}

	@Override
	public void onPostTick(IGregTechTileEntity aBaseMetaTileEntity, long aTick) {
		super.onPostTick(aBaseMetaTileEntity, aTick);
		if (aBaseMetaTileEntity.isServerSide() && aBaseMetaTileEntity.isAllowedToWork()) {
	    	IFluidHandler tTileEntity = aBaseMetaTileEntity.getITankContainerAtSide(aBaseMetaTileEntity.getFrontFacing());
	    	if (tTileEntity != null) {
	    		for (boolean temp = true; temp && mFluid != null;) {
	    			temp = false;
		    		FluidStack tDrained = aBaseMetaTileEntity.drain(ForgeDirection.getOrientation(aBaseMetaTileEntity.getFrontFacing()), Math.max(1, mFluid.amount), false);
		    		if (tDrained != null) {
				    	int tFilledAmount = tTileEntity.fill(ForgeDirection.getOrientation(aBaseMetaTileEntity.getBackFacing()), tDrained, false);
				    	if (tFilledAmount > 0) {
				    		temp = true;
				    		tTileEntity.fill(ForgeDirection.getOrientation(aBaseMetaTileEntity.getBackFacing()), aBaseMetaTileEntity.drain(ForgeDirection.getOrientation(aBaseMetaTileEntity.getFrontFacing()), tFilledAmount, true), true);
				    	}
	    			}
	    		}
	    	}
		}
	}
	
	@Override
	public void saveNBTData(NBTTagCompound aNBT) {
		super.saveNBTData(aNBT);
		aNBT.setByte("mMode", mMode);
	}
	
	@Override
	public void loadNBTData(NBTTagCompound aNBT) {
		super.loadNBTData(aNBT);
		mMode = aNBT.getByte("mMode");
	}
	
	@Override public boolean doesFillContainers()	{return true;}
	@Override public boolean doesEmptyContainers()	{return true;}
	@Override public boolean canTankBeFilled()		{return true;}
	@Override public boolean canTankBeEmptied()		{return true;}
	@Override public boolean displaysItemStack()	{return true;}
	@Override public boolean displaysStackSize()	{return false;}
	
	@Override
	public boolean allowPullStack(IGregTechTileEntity aBaseMetaTileEntity, int aIndex, byte aSide, ItemStack aStack) {
		return aSide == aBaseMetaTileEntity.getFrontFacing() && aIndex == 1;
	}
	
	@Override
	public boolean allowPutStack(IGregTechTileEntity aBaseMetaTileEntity, int aIndex, byte aSide, ItemStack aStack) {
		return aSide == aBaseMetaTileEntity.getFrontFacing() && aIndex == 0;
	}
	
	@Override
	public int getCapacity() {
		return 8000 * (mTier + 1);
	}
	
	@Override
	public void onScrewdriverRightClick(byte aSide, EntityPlayer aPlayer, float aX, float aY, float aZ) {
		if (!getBaseMetaTileEntity().getCoverBehaviorAtSide(aSide).isGUIClickable(aSide, getBaseMetaTileEntity().getCoverIDAtSide(aSide), getBaseMetaTileEntity().getCoverDataAtSide(aSide), getBaseMetaTileEntity())) return;
		mMode = (byte)((mMode + 1) % 8);
		switch (mMode) {
		case 0: UT.Entities.chat(aPlayer, "Outputs Liquids, Steam and Items"); break;
		case 1: UT.Entities.chat(aPlayer, "Outputs Steam and Items"); break;
		case 2: UT.Entities.chat(aPlayer, "Outputs Steam and Liquids"); break;
		case 3: UT.Entities.chat(aPlayer, "Outputs Steam"); break;
		case 4: UT.Entities.chat(aPlayer, "Outputs Liquids and Items"); break;
		case 5: UT.Entities.chat(aPlayer, "Outputs only Items"); break;
		case 6: UT.Entities.chat(aPlayer, "Outputs only Liquids"); break;
		case 7: UT.Entities.chat(aPlayer, "Outputs nothing"); break;
		}
	}
	
	public boolean outputsSteam() {
		return mMode < 4;
	}
	
	public boolean outputsLiquids() {
		return mMode % 2 == 0;
	}
	
	public boolean outputsItems() {
		return mMode % 4 < 2;
	}
	
	@Override
	public int getTankPressure() {
		return +100;
	}
}
